/**
* @file Aramaic CAL code transliteration utilities
* @version 1.1.7
* @author Greg Borota
* @copyright (c) 2017 Greg Borota.
* @license MIT
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/
!function(e,a){"object"==typeof exports&&"undefined"!=typeof module?a(exports,require("aramaic-mapper")):"function"==typeof define&&define.amd?define(["exports","aramaic-mapper"],a):a(e.calCodeUtil={},e.aramaicMapper)}(this,function(e,a){"use strict";var l,u=Object.freeze(Object.create(null,{alaph:{value:")",enumerable:!0},beth:{value:"b",enumerable:!0},gamal:{value:"g",enumerable:!0},dalath:{value:"d",enumerable:!0},he:{value:"h",enumerable:!0},waw:{value:"w",enumerable:!0},zayn:{value:"z",enumerable:!0},heth:{value:"x",enumerable:!0},teth:{value:"T",enumerable:!0},yod:{value:"y",enumerable:!0},kaph:{value:"k",enumerable:!0},lamadh:{value:"l",enumerable:!0},mim:{value:"m",enumerable:!0},nun:{value:"n",enumerable:!0},semkath:{value:"s",enumerable:!0},e:{value:"(",enumerable:!0},pe:{value:"p",enumerable:!0},sadhe:{value:"c",enumerable:!0},qoph:{value:"q",enumerable:!0},resh:{value:"r",enumerable:!0},shin:{value:"$",enumerable:!0},taw:{value:"t",enumerable:!0},peReversed:{value:"P",enumerable:!0},sin:{value:"&",enumerable:!0}})),n=u,r=Object.freeze([n.alaph,n.beth,n.gamal,n.dalath,n.he,n.waw,n.zayn,n.heth,n.teth,n.yod,n.kaph,n.lamadh,n.mim,n.nun,n.semkath,n.e,n.pe,n.sadhe,n.qoph,n.resh,n.shin,n.taw]),t=[n.peReversed,n.sin],m=Object.freeze(r.concat(t)),b=Object.freeze(Object.create(null,{pthaha:{value:"a",enumerable:!0},zqapha:{value:"o",enumerable:!0},rbasa:{value:"e",enumerable:!0},hbasa:{value:"i",enumerable:!0},esasa:{value:"u",enumerable:!0},zlama:{value:"E",enumerable:!0},rwaha:{value:"O",enumerable:!0}})),v=b,s=Object.freeze([v.pthaha,v.zqapha,v.rbasa,v.hbasa,v.esasa]),h=Object.freeze([v.zlama,v.rwaha]),i=Object.freeze(s.concat(h)),c=Object.freeze(Object.create(null,{qushaya:{value:"'",enumerable:!0},rukkakha:{value:",",enumerable:!0},lineaOccultans:{value:"_",enumerable:!0},seyame:{value:"*",enumerable:!0}})),o=c,d=Object.freeze([o.qushaya,o.rukkakha,o.lineaOccultans,o.seyame]),f=Object.freeze(Object.create(null,(l={},l[n.alaph]={value:"a",enumerable:!0},l[n.beth]={value:"b",enumerable:!0},l[n.gamal]={value:"c",enumerable:!0},l[n.dalath]={value:"d",enumerable:!0},l[n.he]={value:"e",enumerable:!0},l[n.waw]={value:"f",enumerable:!0},l[n.zayn]={value:"g",enumerable:!0},l[n.heth]={value:"h",enumerable:!0},l[n.teth]={value:"i",enumerable:!0},l[n.yod]={value:"j",enumerable:!0},l[n.kaph]={value:"k",enumerable:!0},l[n.lamadh]={value:"l",enumerable:!0},l[n.mim]={value:"m",enumerable:!0},l[n.nun]={value:"n",enumerable:!0},l[n.semkath]={value:"o",enumerable:!0},l[n.e]={value:"p",enumerable:!0},l[n.pe]={value:"q",enumerable:!0},l[n.sadhe]={value:"r",enumerable:!0},l[n.qoph]={value:"s",enumerable:!0},l[n.resh]={value:"t",enumerable:!0},l[n.shin]={value:"u",enumerable:!0},l[n.taw]={value:"v",enumerable:!0},l[n.peReversed]={value:"q",enumerable:!0},l[n.sin]={value:"u",enumerable:!0},l[v.pthaha]={value:"w",enumerable:!0},l[v.zqapha]={value:"x",enumerable:!0},l[v.rbasa]={value:"y",enumerable:!0},l[v.zlama]={value:"z",enumerable:!0},l[v.hbasa]={value:"{",enumerable:!0},l[v.esasa]={value:"|",enumerable:!0},l[v.rwaha]={value:"}",enumerable:!0},l[o.qushaya]={value:"",enumerable:!0},l[o.rukkakha]={value:",",enumerable:!0},l[o.lineaOccultans]={value:"",enumerable:!0},l[o.seyame]={value:"",enumerable:!0},l))),p=Object.freeze([";","?","!",".","-",":"]),O=Object.freeze(i.concat(d)),z=Object.freeze([u.beth,u.dalath,u.waw,u.lamadh]),w=function(e){return m.indexOf(e)>-1},y=function(e){return O.indexOf(e)>-1},j=a.hasDotting(y),k=a.clearDotting(y),q=a.getSort(f,w);e.consonantsByName=u,e.consonants=r,e.extraConsonants=t,e.allConsonants=m,e.vowelsByName=b,e.commonVowels=s,e.easternVowels=h,e.vowels=i,e.diacriticsByName=c,e.diacritics=d,e.letterAsciiMap=f,e.punctuation=p,e.dotting=O,e.bdwl=z,e.isConsonant=w,e.isVowel=function(e){return i.indexOf(e)>-1},e.isDiacritic=function(e){return d.indexOf(e)>-1},e.isPunctuation=function(e){return p.indexOf(e)>-1},e.isDotting=y,e.isDotted=j,e.removeDotting=k,e.sort=q,e.isBdwlPrefix=function(e,a){if(a<0)return!1;for(var l=a;l>=0;l--){var u=e.charAt(l);if(w(u)&&-1===z.indexOf(u))return!1}return!0},Object.defineProperty(e,"__esModule",{value:!0})});
